package com.gct.aoid.algorithm;

import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.entity.DiagramCardBaseParam;
import com.gct.aoid.entity.SingleDiagramDiagnoseResult;
import com.gct.common.util.SGTUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.Objects;

/**
 * class name: CalPumpCard2
 *
 * <p>
 * 泵功图计算方法类
 * TODO:优化计算方法流程
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:50
 */
@Slf4j
@Component
public class CalPumpCardCopy {
    /**
     * 没地方用到，暂时先定义到这里
     * <p>
     * 各级杆计算参数
     */
    class ProcessParam {
        public double dzxwyzh;
        public double dzxwy;
        public double dbmaxload;
        public double dbminload;
        public double ddZNXShC;
    }

    private double pumpDepthStep = 20;

    /**
     *
     * @param sgt
     * @param S
     * @param minS
     * @param isLegal
     * @param N
     * @param isPumpAndGushWell
     * @param pumpDepth
     * @param viscosity  传入null即使用默认值
     * @param tubingSize 传入null即使用默认值
     * @return
     */
    public Double[][] cal_bgt(Double[][] sgt,
                              Double S,
                              Double minS,
                              Integer isLegal,
                              Double N,
                              boolean isPumpAndGushWell,
                              Double pumpDepth,
                              Double viscosity,
                              Double tubingSize) {

        //参数冗余
        double /*tmpUpLevel = 0, */tmpDownLevel = 0, downLoadingLevel = 0/*, upLoadingLevel = 0*/;
        int tmpANNNum = 0;
        if (isLegal != 1) return null;//功图不合法不能计算
        if (Objects.isNull(pumpDepth) || pumpDepth <= 0) return null;

        Double[][] cardArray = SGTUtil.diagramReverse(sgt);
        tmpDownLevel = Math.ceil(minS / S / 0.001) * 0.001;
        if (tmpDownLevel < 0.001) tmpDownLevel = 0.001;
        for (int i = 0; i < sgt.length; i++) {
            if (cardArray[0][i] <= S * tmpDownLevel) {
                tmpANNNum++;
                downLoadingLevel += cardArray[1][i];
            }
        }
        downLoadingLevel = downLoadingLevel / tmpANNNum;

        //region 这里没必要计算
//        tmpANNNum = 0;
//        tmpUpLevel = 0.98;
//        while (tmpANNNum == 0) {
//            for (int i = 0; i < sgt.length; i++) {
//                if (cardArray[0][i] >= S * tmpUpLevel) {
//                    tmpANNNum++;
//                    upLoadingLevel = upLoadingLevel + cardArray[1][i];
//                }
//            }
//            tmpUpLevel = tmpUpLevel - 0.001;
//        }
//        upLoadingLevel /= tmpANNNum;
        //endregion
        double[] tmpdDMWY = new double[sgt.length];
        double[] tmpdDMYeZH = new double[sgt.length];
        Double[][] DBU = null;
        double equivalRodDiameter;
        for (int i = 0; i < sgt.length; i++) {
            tmpdDMWY[i] = cardArray[0][i];
            tmpdDMYeZH[i] = cardArray[1][i] * 1000 - downLoadingLevel * 1000;
        }
        double pumpDepthInner = cEquivalentPumpDepthMin(downLoadingLevel);
        ProcessParam pp1 = new ProcessParam();
        while (pp1.dzxwyzh <= (pp1.dbmaxload + pp1.dbminload) * 3.5 / 8) {
            equivalRodDiameter = cEquivalentRodDiameter(downLoadingLevel, pumpDepthInner);
            DBU = subGeJiGanGTWrapper(
                    pumpDepthInner,
                    equivalRodDiameter,
                    sgt.length,
                    sgt.length / 2,
                    tmpdDMWY, tmpdDMYeZH,
                    N,
                    pp1,
                    viscosity,
                    tubingSize);

            if (isPumpAndGushWell) break;
            //如果未迭代到泵深范围,那是因为杆断,喷抽等杆重影响工况造成的
            //除此之外是因为参数匹配问题,如稀油,稠油
            if (pumpDepthInner < pumpDepth) {
                pumpDepthInner += pumpDepthStep;
                if (pumpDepthInner > pumpDepth) pumpDepthInner = pumpDepth;
            } else break;
        }
        for (int i = 0; i < sgt.length; i++) {
            DBU[1][i] = DBU[1][i] / 1000;//将单位转换为kN
        }
        return SGTUtil.diagramReverse(DBU);
    }

    double cEquivalentRodDiameter(double rodWeight, double pumpDepth) {
        return Math.sqrt(rodWeight / 9.8 * 4 / Math.PI / 7.85 / pumpDepth);
    }

    double cEquivalentPumpDepth(double rodWeight, double rodDiameter) {
        return (rodWeight / 9.8 * 4 / Math.PI / 7.85) / (rodDiameter * rodDiameter);
    }

    double cEquivalentPumpDepthMin(double rodWeight) {
        double rodDiameterMaxLimit = 0.055;
        return Math.ceil(cEquivalentPumpDepth(rodWeight, rodDiameterMaxLimit));
    }

    /**
     * 参数改为传入后弃用此方法
     *
     * @param pumpDepthInner
     * @param equivalRodDiameter
     * @param totalPoint
     * @param upPoint
     * @param tmpdDMWY
     * @param tmpdDMYeZH
     * @param N
     * @param pp
     * @param viscosity mPa·s
     * @param tubingSize
     * @return
     */
    @Deprecated
    Double[][] subGeJiGanGTWrapper(double pumpDepthInner,
                                   double equivalRodDiameter,
                                   int totalPoint,
                                   int upPoint,
                                   double[] tmpdDMWY,
                                   double[] tmpdDMYeZH,
                                   double N,
                                   ProcessParam pp,
                                   Double viscosity,
                                   Double tubingSize) {
        /**
         * 默认参数
         * 使用该方法
         *
         */
        if (Objects.isNull(viscosity)) viscosity = 0.022;
        else viscosity /= 1000;
        if (Objects.isNull(tubingSize)) tubingSize = 0.062;

        return subGeJiGanGT(-pumpDepthInner, equivalRodDiameter, 7850, 210000000000l, tmpdDMWY, tmpdDMYeZH,
                N, totalPoint, upPoint, 10, viscosity,
                tubingSize, pp);
    }

    /**
     * @param dNowGanSh  杆长 m
     * @param dGanJing   杆径 m
     * @param GanMidu    杆密度 kg/立方
     * @param DXML_E     弹性模量
     * @param DdiMianWY  地面位移 m
     * @param dYeZhong   液体载荷(目前用的也就是0~载荷差) kn
     * @param chongci    冲次
     * @param TotalPoint 点数
     * @param UpPoint    上行点数
     * @param iNN1       迭代次数(越大越逼近地面功图变化)
     * @param Viscosity  原油粘度 1p=100mPa.s
     * @param Tubingsize 管径
     * @param pp
     * @return
     */
    Double[][] subGeJiGanGT(double dNowGanSh, double dGanJing, double GanMidu, double DXML_E, double[] DdiMianWY,
                            double[] dYeZhong, double chongci, int TotalPoint, int UpPoint, int iNN1,
                            double Viscosity, double Tubingsize, ProcessParam pp) {

        int iNN = iNN1;
        double[] dXShXiGeMa = new double[iNN];
        double[] dXShTao = new double[iNN];
        double[] dXShMiu = new double[iNN];
        double[] dXShDeErTa = new double[iNN];
        double[] dXSha = new double[iNN];
        double[] dXShB = new double[iNN];
        double[] dXShK = new double[iNN];
        double[] dXSHU = new double[iNN];
//        List<List<Double>> Dbu;
        Double[][] Dbu = new Double[2][TotalPoint];
        double[] dbengu = new double[TotalPoint];
        double bmaxload = 0;
        double bminload = 0;
        double[] dbengf = new double[TotalPoint];
        double[] dZhJZhO = new double[iNN];
        double[] dZhJZhP = new double[iNN];
        double[] dZhJZhPianO = new double[iNN];
        double[] dZhJZhPianP = new double[iNN];
        double dZNXShC;
        double tmpdZuNiCup;
        double tmpdZuNiCdown;
        double MinshiftPoint = 1000;
        for (int i = 0; i < iNN; i++) {
            dXShXiGeMa[i] = dFunXShXiGeMa_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, dYeZhong,
                    TotalPoint);
            dXShMiu[i] = dFunXShMiu_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, DdiMianWY, TotalPoint);

            dXShTao[i] = dFunXShTao_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, dYeZhong,
                    TotalPoint);
            dXShDeErTa[i] = dFunXShDeErTa_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, DdiMianWY,
                    TotalPoint);
        }
        dZNXShC = dFunZLXShC(chongci / 60 * 2 * Math.PI, 4968, Viscosity, GanMidu, dGanJing * dGanJing * 0.25 * Math.PI,
                Tubingsize,
                dGanJing, dNowGanSh);
        tmpdZuNiCup = dZNXShC;
        for (int i = 0; i < iNN; i++) {
            dXSha[i] = dFunXSha_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCup, 4968);
            //std::cout << "dXSha[i]:" << dXSha[i] << std::endl;
            dXShB[i] = dFunXShB_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCup, 4968);
            //std::cout << "dXShB[i]:" << dXShB[i] << std::endl;
            dXShK[i] = dFunXShK_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI);
            //std::cout << "dXShK[i]:" << dXShK[i] << std::endl;
            dXSHU[i] = dFunXShU_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI);
            //std::cout << "dXSHU[i]:" << dXSHU[i] << std::endl;
        }
        for (int i = 0; i < iNN; i++) {
            dZhJZhO[i] = dFunO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
            dZhJZhP[i] = dFunP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
            dZhJZhPianO[i] = dFunPianO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                    dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
            dZhJZhPianP[i] = dFunPianP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                    dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
        }

        for (int i = 0; i < UpPoint; i++) {
            dbengu[i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                    60 / chongci / TotalPoint * i);
            dbengf[i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                    iNN,
                    dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * i);
            Dbu[0][i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                    60 / chongci / TotalPoint * i);
            Dbu[1][i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                    iNN,
                    dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * i);

            if (Dbu[0][i] < MinshiftPoint) {
                MinshiftPoint = Dbu[0][i];
                pp.dzxwyzh = Dbu[1][i] / 1000;
                pp.dzxwy = MinshiftPoint;
            }
            if (Dbu[1][i] > bmaxload) {
                bmaxload = Dbu[1][i];
                pp.dbmaxload = Dbu[1][i] / 1000;
            }
            if (Dbu[1][i] < bminload) {
                bminload = Dbu[1][i];
                pp.dbminload = Dbu[1][i] / 1000;
            }
        }
        tmpdZuNiCdown = 1.2 * dZNXShC;
        for (int i = 0; i < iNN; i++) {
            dXSha[i] = dFunXSha_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCdown, 4968);
            dXShB[i] = dFunXShB_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCdown, 4968);
            dXShK[i] = dFunXShK_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI);
            dXSHU[i] = dFunXShU_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI);
        }
        for (int i = 0; i < iNN; i++) {
            dZhJZhO[i] = dFunO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
            dZhJZhP[i] = dFunP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
            dZhJZhPianO[i] = dFunPianO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                    dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
            dZhJZhPianP[i] = dFunPianP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                    dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
        }
        for (int i = UpPoint; i < TotalPoint; i++) {
            dbengu[i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                    60 / chongci / TotalPoint * (i - 1));
            dbengf[i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                    iNN,
                    dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * (i - 1));
            Dbu[0][i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                    dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                    60 / chongci / TotalPoint * (i - 1));
            Dbu[1][i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                    iNN,
                    dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * (i - 1));
            if (Dbu[0][i] < MinshiftPoint) {
                MinshiftPoint = Dbu[0][i];
                pp.dzxwyzh = Dbu[1][i] / 1000;
                pp.dzxwy = MinshiftPoint;
            }
            if (Dbu[1][i] > bmaxload) {
                bmaxload = Dbu[1][i];
                pp.dbmaxload = Dbu[1][i] / 1000;
            }
            if (Dbu[1][i] < bminload) {
                bminload = Dbu[1][i];
                pp.dbminload = Dbu[1][i] / 1000;
            }
        }
        pp.ddZNXShC = dZNXShC;
        return Dbu;
    }

    double dFunXShXiGeMa_n(double dWuMiGa, double DT, int iCShn, double[] dZaiHe, int iDianShu) {
        double dFunXShXiGeMa = 0;
        for (int i = 0; i < iDianShu; i++) {
            dFunXShXiGeMa = dFunXShXiGeMa + dZaiHe[i] * Math.cos(iCShn * dWuMiGa * i * DT) * DT;
        }
        return dFunXShXiGeMa * dWuMiGa / Math.PI;
    }

    double dFunXShTao_n(double dWuMiGa, double DT, int iCShn, double[] dZaiHe, int iDianShu) {
        double dFunXShTao = 0;
        for (int i = 0; i < iDianShu; i++) {
            dFunXShTao = dFunXShTao + dZaiHe[i] * Math.sin(iCShn * dWuMiGa * i * DT) * DT;
        }
        return dFunXShTao * dWuMiGa / Math.PI;
    }

    double dFunXShMiu_n(double dWuMiGa, double DT, int iCShn, double[] dWeiYi, int iDianShu) {
        double dFunXShMiu_n = 0;
        for (int i = 0; i < iDianShu; i++) {
            dFunXShMiu_n = dFunXShMiu_n + dWeiYi[i] * Math.cos(iCShn * dWuMiGa * i * DT) * DT;
        }
        //double temp = dFunXShMiu_n;
        return dFunXShMiu_n * dWuMiGa / Math.PI;
    }

    double dFunXShDeErTa_n(double dWuMiGa, double DT, int iCShn, double[] dWeiYi, int iDianShu) {
        double dFunXShDeErTa_n = 0;
        for (int i = 0; i < iDianShu; i++) {
            dFunXShDeErTa_n = dFunXShDeErTa_n + dWeiYi[i] * Math.sin(iCShn * dWuMiGa * i * DT) * DT;
        }
        return dFunXShDeErTa_n * dWuMiGa / Math.PI;
    }

    double dFunFLYZaiHe(double dWuMiGa, int iCShn, double[] dXiGeMa, double[] dTao, double dShiJian_t) {
        double dFunFLYZaiHe = dXiGeMa[0] / 2;
        for (int i = 1; i < iCShn; i++) {
            dFunFLYZaiHe = dFunFLYZaiHe + dXiGeMa[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                    dTao[i] * Math.sin(i * dWuMiGa * dShiJian_t);
        }
        return dFunFLYZaiHe;
    }

    double dFunYWeiYi(double dWuMiGa, int iCShn, double[] dMiu, double[] dDeErTa, double dShiJian_t) {
        double dFunFLYWeiYi = dMiu[0] / 2;
        for (int i = 1; i < iCShn; i++) {
            dFunFLYWeiYi = dFunFLYWeiYi + dMiu[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                    dDeErTa[i] * Math.sin(i * dWuMiGa * dShiJian_t);
        }
        return dFunFLYWeiYi;
    }

    double dFunSH(double dz) {
        return (Math.exp(dz) - Math.exp(-dz)) * 0.5;
    }

    double dFunCH(double dz) {
        return (Math.exp(dz) + Math.exp(-dz)) * 0.5;
    }

    double dFunXSha_n(double dWuMiGa, int iCShn, double dCShC, double dCSHa) {
        iCShn++;
        double te =
                iCShn * dWuMiGa / dCSHa / Math.sqrt(2) * Math.sqrt(1 + Math.sqrt(1 + Math.pow
                        (dCShC / iCShn / dWuMiGa, 2)));
        return te;
    }

    double dFunXShB_n(double dWuMiGa, int iCShn, double dCShC, double dCSHa) {
        iCShn++;
        return iCShn * dWuMiGa / dCSHa / Math.sqrt(2) * Math.sqrt(-1 + Math.sqrt(1 + Math.pow
                (dCShC / iCShn / dWuMiGa, 2)));
    }

    double dFunXShK_n(double dan, double dBn, double DXiGeMa, double dTaon, double dE, double dAr) {
        return (DXiGeMa * dan + DXiGeMa * dBn) / (dE * dAr * (Math.pow(dan, 2) + Math.pow(dBn, 2)));
    }

    double dFunXShU_n(double dan, double dBn, double DXiGeMan, double dTaon, double dE, double dAr) {
        return (DXiGeMan * dBn - dTaon * dan) / (dE * dAr * (Math.pow(dan, 2) + Math.pow(dBn, 2)));
    }

    double dFunZLXShC(double dWuMiGa, double dCSHa, double dCSh_u, double dRor, double dAr, double dDt,
                      double dDr, double dL) {
        double tmpm, tmpQXSh, tmpFM;
        double tmpB1, tmpB2;
        tmpm = dDt / dDr;
        tmpFM = dWuMiGa * dL / (dCSHa * Math.sin(dWuMiGa * dL / dCSHa)) + Math.cos(dWuMiGa * dL / dCSHa);
        tmpFM = 2 / tmpFM;
        tmpB1 = (tmpm * tmpm - 1) / (2 * Math.log(tmpm)) - 1;
        tmpB2 = Math.pow(tmpm, 4) - 1 - Math.pow((tmpm * tmpm - 1), 2) / Math.log(tmpm);
        tmpQXSh = 2 * Math.PI * dCSh_u / dRor / dAr;
        //double t = Math.log(tmpm);
        double temp = tmpQXSh * (1 / Math.log(tmpm) + 4 * (tmpB1 + 1) / tmpB2 * (tmpB1 + tmpFM));
        return temp;
    }

    double
    dFunO_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun) {
        double t = (dKn * dFunCH(dBn * dx) + dDeErTan * dFunSH(dBn * dx)) * Math.sin(dan * dx) +
                (dUn * dFunSH(dBn * dx) + dMiun * dFunCH(dBn * dx)) * Math.cos(dan * dx);
        return t;
    }

    double
    dFunP_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun) {
        double t = (dKn * dFunSH(dBn * dx) + dDeErTan * dFunCH(dBn * dx)) * Math.cos(dan * dx) -
                (dUn * dFunCH(dBn * dx) + dMiun * dFunSH(dBn * dx)) * Math.sin(dan * dx);
        return t;
    }

    double dFunPianO_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn,
                       double dMiun, double dTaon, double DXiGeMan, double dE, double dAr) {
        double t = (dTaon / (dE * dAr) * dFunSH(dBn * dx) + (dDeErTan * dBn - dan * dMiun) * dFunCH(dBn * dx)) *
                Math.sin(dan * dx) +
                (DXiGeMan / (dE * dAr) * dFunCH(dBn * dx) + (dDeErTan * dan + dBn * dMiun) * dFunSH(dBn * dx)) *
                        Math.cos(dan * dx);
        return t;
    }

    double dFunPianP_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn,
                       double dMiun, double dTaon, double DXiGeMan, double dE, double dAr) {
        return (dTaon / (dE * dAr) * dFunCH(dBn * dx) + (dDeErTan * dBn - dan * dMiun) * dFunSH(dBn * dx)) *
                Math.cos(dan * dx) -
                (DXiGeMan / (dE * dAr) * dFunSH(dBn * dx) + (dDeErTan * dan + dBn * dMiun) * dFunCH(dBn * dx)) *
                        Math.sin(dan * dx);
    }

    double
    dFunUxt(double dx, double dWuMiGa, double dXiGeMa0, double dMiu0, double dE, double dAr, int iCShn,
            double[] dOn, double[] dPn, double dShiJian_t) {
        double dFunUxt = dXiGeMa0 / (2 * dE * dAr) * dx + dMiu0 / 2;
        for (int i = 1; i < iCShn; i++) {
            dFunUxt = dFunUxt + dOn[i] * Math.cos(i * dWuMiGa * dShiJian_t) + dPn[i] * Math.sin
                    (i * dWuMiGa * dShiJian_t);
        }
        return dFunUxt;
    }

    double dFunFxt(double dWuMiGa, double dXiGeMa0, double dE, double dAr, int iCShn, double[] dPianOn,
                   double[] dPianPn, double dShiJian_t) {
        double dFunFxt = 0;
        for (int i = 1; i < iCShn; i++) {
            dFunFxt = dFunFxt + dPianOn[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                    dPianPn[i] * Math.sin(i * dWuMiGa * dShiJian_t);
        }
        dFunFxt = dFunFxt + dXiGeMa0 / (2 * dE * dAr);
        double t = dE * dAr * dFunFxt;
        return t;
    }

}
