package com.gct.aoid.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.gct.common.util.DateTimeUtil;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;

/**
 * class name: MybatisPlusAutoFill
 *
 * @author gxt
 * @version 1.0
 * @since 2022/5/31 下午2:54 周二
 */
@Component
public class MybatisPlusAutoFill implements MetaObjectHandler {
    @Override
    public void insertFill(MetaObject metaObject) {
        LocalDateTime localDateTime = DateTimeUtil.formatDateTime(DateTimeUtil.formatString(LocalDateTime.now()).replaceAll("T"," "));
        this.setFieldValByName("createTime",localDateTime,metaObject);
        this.setFieldValByName("updateTime",localDateTime,metaObject);
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        LocalDateTime localDateTime = DateTimeUtil.formatDateTime(DateTimeUtil.formatString(LocalDateTime.now()).replaceAll("T"," "));
        this.setFieldValByName("updateTime",localDateTime,metaObject);
    }
}
