package com.gct.aoid.controller;


import com.alibaba.excel.EasyExcel;
import com.gct.aoid.entity.AoidProductRetrieval;
import com.gct.aoid.entity.Vo.ProductRetrievalVo;
import com.gct.aoid.service.AoidProductRetrievalService;
import com.gct.aoid.utils.ExcelMergeStrategy;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.security.Principal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ConcurrentHashMap;

/**
 * <p>
 * 产量检索表 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2022-10-24
 */
@RestController
@RequestMapping("/aoidProductRetrieval")
public class AoidProductRetrievalController {

    @Autowired
    AoidProductRetrievalService aoidProductRetrievalService;

    private final ConcurrentHashMap<String,Boolean> hashMap = new ConcurrentHashMap<>();

    @PostMapping("/getListData")
    public Result getListData(@RequestBody ProductRetrievalVo productRetrievalVo){
        return Result.ok(aoidProductRetrievalService.getListData(productRetrievalVo));
    }

    @PostMapping("/updateData")
    public Result updateData(@RequestBody AoidProductRetrieval aoidProductRetrieval){
        return Result.ok(aoidProductRetrievalService.updateData(aoidProductRetrieval));
    }
    @PostMapping("/downLoadExcel")
    public void downLoadExcel(@RequestBody ProductRetrievalVo productRetrievalVo, HttpServletResponse response) throws IOException{
        List<AoidProductRetrieval> retrievalList = aoidProductRetrievalService.getListData(productRetrievalVo);
        // 设置响应格式
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        Map<String, Integer[]> map = new HashMap<>();
        int pos =0;
        map.put("determineMode",new Integer[retrievalList.size()]);
        map.put("systemTotalVal",new Integer[retrievalList.size()]);
        map.put("determineVal",new Integer[retrievalList.size()]);
        for ( int i = 0; i < retrievalList.size(); i++) {
            {
               map.get("determineMode")[i]=0;
               map.get("systemTotalVal")[i]=0;
               map.get("determineVal")[i]=0;
            }
            if (i == 0) {
                map.get("determineMode")[i]=1;
                map.get("systemTotalVal")[i]=1;
                map.get("determineVal")[i]=1;
            } else {
                if (retrievalList.get(i).getDetermineMode().equals(retrievalList.get(i-1).getDetermineMode())) {
                    map.get("determineMode")[pos]+=1;
                    if(retrievalList.get(i).getIsSummary()==1) {
                        map.get("determineVal")[pos]+=1;;
                        map.get("systemTotalVal")[pos]+=1;
                    }else {
                        map.get("determineVal")[i]=1;;
                        map.get("systemTotalVal")[i]=1;
                    }
                } else {
                    map.get("determineMode")[i]=1;
                    map.get("systemTotalVal")[i]=1;
                    map.get("determineVal")[i]=1;
                    pos = i;
                }
            }
        }
        String fileName = URLEncoder.encode("one-to-many", "UTF-8");
        response.setHeader("Content-disposition", "attachment;filename=" + fileName + ".xlsx");
        EasyExcel.write(response.getOutputStream(), AoidProductRetrieval.class)
                .sheet()
                .registerWriteHandler(new ExcelMergeStrategy(map))
                .doWrite(retrievalList);
    }

    @GetMapping("/insertData")
    public Result insertData(@RequestParam("date") String date, @AuthenticationPrincipal Principal user){
        if (hashMap.containsKey(user.getName())){
            return Result.ok(true);
        }else {
            hashMap.put(user.getName(),true);
            CompletableFuture.runAsync(() -> {
                aoidProductRetrievalService.insertData(date);
                hashMap.remove(user.getName());
            });
        }
        return Result.ok(true);
    }
}

