package com.gct.aoid.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.entity.WellAttr;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.impl.CalibrationParameterService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2021-01-31
 */
@Api(value = "AoidSinglegtYieldController", description = "功图量液")
@RestController
@RequestMapping("/aoidSinglegtYield")

public class AoidSinglegtYieldController {

    @Autowired  
    public AoidSinglegtYieldService aoidSinglegtYieldService;

    @Autowired
    private com.gct.aoid.service.impl.calDiagramProductionCorrectService calDiagramProductionCorrectService;

    public static AtomicInteger atomicIntegerRealYield = new AtomicInteger(0);

    @Autowired
    private CalibrationParameterService calibrationParameterService;


    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息" ,notes = "根据井号和日期时间段查询量液的基本信息")
    @PostMapping("/getAoidSinglegtYieldInfo")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(@RequestBody AoidYeildVo aoidYeildVo){
       List list= aoidSinglegtYieldService.getAoidSinglegtYieldListByOneDay(aoidYeildVo.getWellId(),aoidYeildVo.getStartDate());
        return list==null||list.size()==0?Result.error("量液信息未找到"):Result.ok(list);
    }

    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息--分页" ,notes = "根据井号和日期时间段查询量液的基本信息--分页")
    @PostMapping("/getAoidSinglegtYieldInfoByPages")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(@RequestBody AoidYeildVo aoidYeildVo) throws ParseException {
        String datePattern = "\\d{4}-\\d{1,2}-\\d{1,2}";
        if(aoidYeildVo.getStartDate()==null){
            LocalDate now = LocalDate.now();
            aoidYeildVo.setStartDate(now.format(DateTimeFormatter.ISO_DATE));
            aoidYeildVo.setEndDate(now.plusDays(1).format(DateTimeFormatter.ISO_DATE));
        }
        if (aoidYeildVo.getStartDate()==null||aoidYeildVo.getEndDate()==null ||!aoidYeildVo.getStartDate().matches(datePattern) || !aoidYeildVo.getEndDate().matches(datePattern))
            return Result.error("日期格式有误");

        Page<Map<String,Object>> mapPage =  aoidSinglegtYieldService.getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(
                aoidYeildVo.getWellId(),
                aoidYeildVo.getStartDate(),
                aoidYeildVo.getEndDate(),
                aoidYeildVo.getPage(),
                aoidYeildVo.getSize());
        return mapPage==null||mapPage.getSize()==0?Result.error("未找到"):Result.ok(mapPage);
    }

    @GetMapping("/getResultIdByWellId")
    public Result getResultIdByWellId(@RequestParam String wellId,@RequestParam String date,@RequestParam boolean isOnlyShowErrorGt,
                                      @RequestParam("pageSize") int pageSize ,@RequestParam("pageNum") int pageNum){
        return Result.ok(aoidSinglegtYieldService.getResultIdByWellId(wellId,date,isOnlyShowErrorGt,pageSize,pageNum));
    }

    @ApiOperation(value = "功图浏览", notes = "根据参数条件进行功图浏览")
    @GetMapping("/getCvrresultByTimeBrowSingle")
    public Result getCvrresultByTimeBrowSingle(
            @ApiParam("开始时间") @RequestParam(required = false) String beginTime,
            @ApiParam("结束时间") @RequestParam(required = false) String endTime,
            @ApiParam("orgid") @RequestParam(required = false) String orgid,
            @ApiParam("井号") @RequestParam(required = false) String wellId,
            @ApiParam("判断功图是否异常") @RequestParam(required = false) Integer sgtIsLegal,
            @ApiParam("当前页") @RequestParam Integer pageNum,
            @ApiParam("页面大小") @RequestParam Integer pageSize) {
        return Result.ok(aoidSinglegtYieldService.getCvrresultByTimeBrowSingle(beginTime, endTime,orgid, wellId,sgtIsLegal, pageNum, pageSize));
    }



    @ApiOperation(value = "recaliBrate(重新标定)", notes = "重新标定")
    @GetMapping("/recaliBrate")
    public void recaliBrate() throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {
        if (atomicIntegerRealYield.get()!=0) {
            return;
        }
        ExecutorService pool = Executors.newSingleThreadExecutor();
        pool.execute(new Runnable() {
            @SneakyThrows
            @Override
            public void run() {
                System.out.println("reCal--->开始重新标定----");
                atomicIntegerRealYield.set(2);
                calibrationParameterService.Calibrationtask();  // 0 没有计算任务 1 计算完成  2 计算中
                atomicIntegerRealYield.set(1);
                System.out.println("reCal--->标定结束，请查看----");
            }
        });

    }
    @ApiOperation(value = "getParamCalTaskExecutorRecaliBrate(重新标定任务的进度)", notes = "重新标定任务的进度")
    @GetMapping("/getParamCalTaskExecutorRecaliBrate")
    public Result getParamCalTaskExecutorYieldError (){
        int i = atomicIntegerRealYield.get();
        if (i==1){
            atomicIntegerRealYield.set(0);
        }
        return Result.ok(i);
    }

    @ApiOperation(value = "addCbPcDevWellAttr(添加单井属性数据)", notes = "添加单井属性数据")
    @PostMapping("/addCbPcDevWellAttr")
    public void addCbPcDevWellAttr(@RequestBody WellAttr wellAttr)throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException{
        aoidSinglegtYieldService.addCbPcDevWellAttr(wellAttr);
    }
    @ApiOperation(value = "功图叠加", notes = "根据时间获取诊断功图")
    @GetMapping("/getOverlayPaging")
    public Result getOverlayPaging(
            @ApiParam(name = "pageNum",value = "当前页",required = true) @RequestParam("pageNum") Integer pageNum,
            @ApiParam(name = "pageSize",value = "页大小",required = true) @RequestParam("pageSize") Integer pageSize,
            @ApiParam(name = "wellId",value = "井ID",required = true) @RequestParam("wellId") String wellId,
            @ApiParam(name = "beginTime",value = "开始时间（格式：YYYY-MM-dd HH:mm:ss）",required = true) @RequestParam("beginTime") String beginTime,
            @ApiParam(name = "endTime",value = "结束时间（格式：YYYY-MM-dd HH:mm:ss）",required = true) @RequestParam("endTime") String endTime) {
        return Result.ok(aoidSinglegtYieldService.getOverlayPaging(pageNum,pageSize,wellId,beginTime,endTime));
    }
    @ApiOperation(value = "功图叠加查询", notes = "根据时间获取诊断功图")
    @GetMapping("/getCvrresultByTime")
    public Result getCvrresultByTime(
            @ApiParam("开始时间") @RequestParam String beginTime,
            @ApiParam("结束时间") @RequestParam String endTime,
            @ApiParam("井号") @RequestParam String wellId,
            @ApiParam("当前页") @RequestParam Integer pageNum,
            @ApiParam("页面大小") @RequestParam Integer pageSize) {
        return Result.ok(aoidSinglegtYieldService.getCvrresultByTime(beginTime, endTime, wellId, pageNum, pageSize));
    }
}

