package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 量液异常参数配置表
 * </p>
 *
 * @author gxt
 * @since 2021-12-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="AoidParamSetting对象", description="量液异常参数配置表")
@TableName(schema = "aoid",value = "aoid_param_setting")
public class AoidParamSetting extends Model<AoidParamSetting> {

    private static final long serialVersionUID=1L;

    private Integer id;

    @ApiModelProperty(value = "参数名称")
    private String paramName;

    @ApiModelProperty(value = "参考值")
    private String reference;

    @ApiModelProperty(value = "波动范围(%)")
    private Double fluctuationAmplitude;

    @ApiModelProperty(value = "是否启用( 1 true 2 false 默认 1)")
    private Integer enable;

    @ApiModelProperty(value = "是否启用")
    private String sourceCol;

    @ApiModelProperty(value = "是否启用")
    private String targetCol;

    @ApiModelProperty(value = "优先级字段,默认使用最高 1 ,按顺序由高带低")
    private Integer sort;


    @TableField(exist = false)
    private boolean enableView;

    @ApiModelProperty(value = "液量算法配置")
    private String threshold;


    @Override
    protected Serializable pkVal() {
        return null;
    }

}
