package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 *
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "AoidSinglegtYield对象", description = "")
@TableName(schema = "aoid", value = "aoid_singlegt_yield")
public class AoidSinglegtYield extends Model<AoidSinglegtYield> {

    private static final long serialVersionUID = 1L;

    private String wellId;

    private String wellCommonName;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime prodDate;

    private Double stroke;

    private Double frequence;

    private Double bj;

    private Double bs;

    private Double cmd;

    private Double yzzj;

    private Double sxzh;

    private Double xxzh;

    private String sgt;

    private String bgt;

    private String zdjg;

    private Double a2LiqProdDaily;
    private Double a2OilProdDaily;
    private Double a2WaterProdDaily;

    private Integer sgtIsLegal;
    private Integer calIsNormal;
    private Double liqProdDaily;
    private Double a2GasProdDaily;
    private Double a2WaterCut;
    private String a2Remark;
    private Integer a2ProdTime;

    private Double oilProdDaily;

    private Double gasProdDaily;

    private Double testLiquVolDaily;

    private String eczdjg;

    private Double bx;

    private Double hsl;

    private Double flag;

    private Double bdxs;

    private Double llpl;

    private Double zcc;

    private Double ycc;

    private Double sjcc;

    private Double yxcc;

    private Double ccss;

    private Double lsss;

    private Double gyss;

    private Double pumpdepth;

    private Double hy;

    private Double yy;

    private Double ty;

    private Double waterProdDaily;

    private Double scsj;

    private Double qyb;

    private Double strokeRatio;

    private Double djdy;

    private Double hjwd;

    private Double ybdl;

    private Double xhqd;

    private String sbh;
    private Double smd;
    private Double ymd;

    private Double dym;

    private Double a2Dym;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime createTime;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "remark")
    private String remark;

    @TableField(exist = false)
    private String zdjgfx;


    @ApiModelProperty(value = "'实时载荷差'")
    private Double loadDifference;

    @ApiModelProperty(value = "实时面积")
    private String area;

    @ApiModelProperty(value = "比对日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime comparisonProdDate;

    @ApiModelProperty(value = "比对系数")
    private Double comparisonCoefficient;

    @ApiModelProperty(value = "比对产量")
    private Double comparisonYield;

    @ApiModelProperty(value = "比对有效冲程")
    private String comparisonYxcc;


    @ApiModelProperty(value = "比对载荷差")
    private String comparisonLoadDifference;

    @ApiModelProperty(value = "比对面积")
    private String comparisonArea;

    @ApiModelProperty(value = "有效冲程差率")
    private String yxccRate;

    @ApiModelProperty(value = "载荷差率")
    private String loadDifferenceRate;

    @ApiModelProperty(value = "面积差率")
    private String areaRate;

    private String measureFlag;

    @ApiModelProperty(value = "是否停井")
    private String isStopWell;


    @ApiModelProperty(value = "参数说明")
    private String parmExplain;

    @ApiModelProperty(value = "参数标识")
    private String parmFlag;

    @TableField(exist = false)
    private List<List<Double>> sgtUp;
    @Override
    protected Serializable pkVal() {
        return this.wellId;
    }

}
