package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 *
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "YieldErrorAnalysis对象", description = "")
@TableName(schema = "aoid", value = "yield_error_analysis")
public class YieldErrorAnalysis extends Model<YieldErrorAnalysis> {



    @ApiModelProperty(value = "井Id")
    private String wellId;

    @ApiModelProperty(value = "作业区")
    private String zyq;


    @ApiModelProperty(value = "日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private LocalDateTime prodDate;


    @ApiModelProperty(value = "今日日产液量")
    private Double todayLiqProdDaily;

    @ApiModelProperty(value = "今日A2产液量")
    private Double todayA2LiqProdDaily;


    @ApiModelProperty(value = "今日油压")
    private Double todayOilPressure;


    @ApiModelProperty(value = "今日套压")
    private Double todayCasingPressure;


    @ApiModelProperty(value = "今日误差率")
    private Double todayYieldError;


    @ApiModelProperty(value = "今日日志备注")
    private String todayRemark;


    @ApiModelProperty(value = "最新标定日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private LocalDateTime calibrationNew;

    @ApiModelProperty(value = "汇总说明")
    private String summaryDescription;


    @ApiModelProperty(value = "是否符合预期")
    private String isExpect;






}
