package com.gct.aoid.job;

import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.job.properties.JobParamConfigurationProperties;
import com.gct.aoid.job.properties.ProdTimeCorrectProperty;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;

/**
 * class name: CoefficientCorrectionJob
 *
 * @author 王森玉
 * @version 1.0
 * @since 2021/9/3 下午14:48 周五
 */
@Slf4j
public class CoefficientCorrectionJob extends QuartzJobBean {

    public static ThreadLocal<Boolean> threadLocal = new ThreadLocal<Boolean>();

    @Autowired
    private com.gct.aoid.service.impl.calDiagramProductionCorrectService calDiagramProductionCorrectService;

    @Autowired
    private BaseDataClient baseDataClient;
    /**
     * @Author 王森玉
     * @Description 每七天执行一次量液系数修正服务
     * @Date 14:23 2021.9.6
     * @Param
     * @return void
     **/
    protected void executeInternal(JobExecutionContext context){
        String jobName =  "CoefficientCorrection";
        String jobGroup = "CoefficientCorrectionJob_Group";
        log.info("*===>[quartz-job:start]JobName:{},JobGroup:{},Time:{}", jobName, jobGroup, LocalDateTime.now().format(DateTimeFormatter.ISO_DATE_TIME));
        try {
             threadLocal.set(true);
            calDiagramProductionCorrectService.calxz();

        } catch (Exception e) {
            log.error("[quartz-job:run error]JobName:{},JobGroup:{}\n-----------cause by:{}", jobName, jobGroup, e.getStackTrace());
            e.printStackTrace();
        }finally {
            threadLocal.remove();
        }
        //endregion
        log.info("*===>[quartz-job:completed]JobName:{},JobGroup:{},Time:{}", jobName, jobGroup, LocalDateTime.now().format(DateTimeFormatter.ISO_DATE_TIME));
    }
}
