package com.gct.aoid.job;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.job.properties.MutableJobConfigProperties;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import lombok.extern.slf4j.Slf4j;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.stream.Collectors;

import static java.util.stream.Collectors.toList;

/**
 * class name: insertDefultAoidDailyData
 *
 * @author gxt
 * @version 1.0
 * @since 2022/2/16 下午3:48 周三
 */
@Slf4j
public class insertDefultAoidDailyData extends QuartzJobBean {
    @Autowired
    BaseDataClient baseDataClient;
    @Autowired
    AoidDailyYieldService aoidDailyYieldService;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        QueryWrapper<AoidDailyYield> wrapper = new QueryWrapper<AoidDailyYield>()
                .eq("prod_date",LocalDateTime.now());
        List<AoidDailyYield> aoidDailyYields = aoidDailyYieldService.getBaseMapper().selectList(wrapper);
        if (!aoidDailyYields.isEmpty()) return;
        LocalDateTime now = LocalDateTime.now();
        LocalDateTime localDateTime = DateTimeUtil.formatDateTime(LocalDate.now() + " 00:01:00");
        if (now.isAfter(localDateTime) && now.minusMinutes(1).isBefore(localDateTime)){
            log.info("开始执行自动插入默认量液汇总数据");
            List<Map<String, Object>> list = JSONObject.parseObject(JSONObject.parseObject(baseDataClient.getWellControlList(), Result.class).getData().toString(), List.class);
            List<AoidDailyYield> collect = list.stream().map(x -> {
                AoidDailyYield aoidDailyYield = new AoidDailyYield();
                aoidDailyYield.setWellId(String.valueOf(x.get("wellId")));
                aoidDailyYield.setWellCommonName(String.valueOf(x.get("wellCommonName")));
                aoidDailyYield.setProdDate(DateTimeUtil.formatDateTime(LocalDate.now()+" 00:00:00"));
                aoidDailyYield.setLiqProdDaily(null);
                aoidDailyYield.setOilProdDaily(null);
                aoidDailyYield.setWaterProdDaily(null);
                aoidDailyYield.setGasProdDaily(null);
                aoidDailyYield.setBx(0D);
                aoidDailyYield.setLlpl(0d);
                aoidDailyYield.setProdTime(0);
                aoidDailyYield.setClxs(0d);
                aoidDailyYield.setStroke(0d);
                aoidDailyYield.setFrequence(0d);
                aoidDailyYield.setWaterCut(0d);
                aoidDailyYield.setBj(0d);
                aoidDailyYield.setBs(0d);
                aoidDailyYield.setCmd(0d);
                aoidDailyYield.setYz(0d);
                aoidDailyYield.setScsj(0d);
                aoidDailyYield.setYy(0d);
                aoidDailyYield.setHy(0d);
                aoidDailyYield.setTy(0d);
                aoidDailyYield.setBz(null);
                aoidDailyYield.setSfyc(0d);
                aoidDailyYield.setDym(0d);
                aoidDailyYield.setA2Dym(0d);
                aoidDailyYield.setRcy2(0d);
                aoidDailyYield.setRcu2(0d);
                aoidDailyYield.setRcs2(0d);
                aoidDailyYield.setA2LiqProdDaily(null);
                aoidDailyYield.setA2OilProdDaily(null);
                aoidDailyYield.setA2WaterProdDaily(null);
                aoidDailyYield.setA2GasProdDaily(null);
                aoidDailyYield.setA2ProdTime(0);
                aoidDailyYield.setA2WaterCut(null);
                aoidDailyYield.setYxgts(0);
                aoidDailyYield.setErrorgts(0);
                aoidDailyYield.setZdjg(null);
                aoidDailyYield.setDjdy(0d);
                aoidDailyYield.setZyq(null);
                aoidDailyYield.setJlz(null);
                aoidDailyYield.setHjwd(0d);
                aoidDailyYield.setYbdl(0d);
                aoidDailyYield.setSbh(null);
                aoidDailyYield.setXhqd(0d);
                aoidDailyYield.setYl(0d);
                aoidDailyYield.setRzbz(null);
                aoidDailyYield.setSmd(1.0);
                aoidDailyYield.setYmd(0.85);
                aoidDailyYield.setQyb(0d);
                return aoidDailyYield;
            }).collect(toList());
            collect.forEach(x->{
                aoidDailyYieldService.getBaseMapper().insert(x);
            });
            log.info("自动插入默认量液汇总数据完成");
        }
    }
}
