package com.gct.aoid.job.properties;

import lombok.Data;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.Map;

/**
 * class name: JobParamConfigurationProperties
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/7/16 上午8:52 Fri
 */
@Data
public class JobParamConfigurationProperties {
    private String[] orgId = new String[]{"1"};

    private String logPath = "/logs/job/";

    private String startDate = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));

    private String startTimeEveryDay = "00:00:00";

    private String jobName = "DEFAULT";

    private String jobGroup = "DEFAULT_GROUP";

    private int wellBatch = 10;

    private boolean isRunning = true;
    private int status = 0; //0 未启动 , 1 正常运行,2 暂停 ,3 运行超时异常 ,

    private String calLiqDate = "08:00:00";

    private ProdTimeCorrectProperty[] prod;

    private boolean enabled = false;
}
