package com.gct.aoid.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.entity.Vo.AoidYeildStatDayVo;
import com.gct.aoid.entity.Vo.AoidYeildStatMonthVo;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;


/**
 * @Author: Jyx
 * @Since: 2021/1/28 22:23
 */
@Mapper
public interface AoidDailyYieldMapper extends BaseMapper<AoidDailyYield> {


    List<AoidDailyYield> getAoidDailyYieldInfoByWellIdAndPorDatePeriod(@Param("wellId") String wellId,@Param("startDate") String startDate,@Param("endDate") String endDate);
    String getAVGForA2LiqProdDaily(@Param("wellId") String wellId,@Param("date") String date);

    List<Map<String, Object>> getAoidLiqProdDailyForSevenDay(@Param("date") String date);

    List<Map<String, Object>> getLiqWarring(@Param("pordDate") LocalDateTime pordDate,@Param("wellIdList") List<String> wellIdList,
                                            @Param("currentPage") Integer currentPage,@Param("pageSize") Integer pageSize);

    Integer getLiqWarringCount(@Param("pordDate") LocalDateTime pordDate,@Param("wellIdList") List<String> wellIdList);

    List<Map<String, Object>> getLiqDailyYestAndTenAndMonth(@Param("prodDate") LocalDateTime prodDate);

    List<AoidDailyYield> findByJhAoidDaily(@Param("jh") String jh, @Param("start") String start, @Param("end") String end);

    List<AoidDailyYield> findByJhAoidDailyA2(@Param("jh") String jh, @Param("prodDate") String prodDate);

    IPage<AoidDailyYield> findWellWc(IPage<?> page,
                                     @Param("zyq") String zyq,
                                     @Param("wcStart") Double wcStart,
                                     @Param("wcEnd") Double wcEnd,
                                     @Param("cylStart") Double cylStart,
                                  @Param("cylEnd") Double cylEnd,
                                  @Param("dateStart") String dateStart,
                                  @Param("dateEnd") String dateEnd);

    IPage<AoidDailyYield> findWellWcJhvalue(IPage<?> page,
                                     @Param("wcStart") Double wcStart,
                                     @Param("wcEnd") Double wcEnd,
                                     @Param("cylStart") Double cylStart,
                                     @Param("cylEnd") Double cylEnd,
                                     @Param("jh") String jh,
                                     @Param("dateStart") String dateStart,
                                     @Param("dateEnd") String dateEnd);

    AoidDailyYield findWellWcJh(
                                     @Param("jh") String jh,
                                     @Param("dateStart") String dateStart,
                                     @Param("dateEnd") String dateEnd);

    List<AoidYeildStatMonthVo> selectAoidDailyYieldLastMonth(@Param("wellIdList") List<String> wellIdList);

    AoidYeildStatMonthVo selectAoidDailyYieldLastDay(@Param("wellIdList") List<String> wellIdList, @Param("localDate") LocalDate localDate);

    AoidYeildStatMonthVo selectAoidDailyYieldErrorGtsLastDay(@Param("wellIdList") List<String> wellIdList, @Param("localDate") LocalDate localDate);



    List<AoidYeildStatDayVo> selectAoidDailyYieldDay(AoidYeildVo aoidYeildVo);

    List<AoidYeildStatDayVo> selectAoidDailyYieldErrorGtsDay(AoidYeildVo aoidYeildVo);

    List<AoidYeildStatDayVo> selectAoidDailyYieldErrorGtsGroupByWellName(AoidYeildVo aoidYeildVo);

}
