package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.aoid.entity.AoidParamSetting;
import com.gct.aoid.mapper.AoidParamSettingMapper;
import com.gct.aoid.service.AoidParamSettingService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 量液异常参数配置表 服务实现类
 * </p>
 *
 * @author gxt
 * @since 2021-12-21
 */
@Service
public class AoidParamSettingServiceImpl extends ServiceImpl<AoidParamSettingMapper, AoidParamSetting> implements AoidParamSettingService {

    @Override
    public List<AoidParamSetting> getAoidParamSetting() {
        List<AoidParamSetting> list = baseMapper.selectList(
                new LambdaQueryWrapper<AoidParamSetting>().orderByAsc(AoidParamSetting::getSort)
        );
        list.forEach(x->{
            if (x.getEnable() == 1) x.setEnableView(true);
            else if (x.getEnable() ==2 )x.setEnableView(false);
        });
        return list;
    }

    @Override
    public boolean editAoidParamSetting(JSONObject jsonObject) {
        JSONArray parameterData = jsonObject.getJSONArray("parameterData");
        List<AoidParamSetting> list = new ArrayList<>();
        AoidParamSetting aoidParamSetting;
        for (Object parameterDatum : parameterData) {
            Map<String, Object> map = (Map<String, Object>) parameterDatum;
            aoidParamSetting = new AoidParamSetting();
            aoidParamSetting.setId((Integer) map.get("id"));
            aoidParamSetting.setParamName(String.valueOf(map.get("paramName")));
            aoidParamSetting.setFluctuationAmplitude(Double.parseDouble(String.valueOf(map.get("fluctuationAmplitude"))));
            aoidParamSetting.setReference(String.valueOf(map.get("reference")));
            if (Boolean.parseBoolean(String.valueOf(map.get("enableView")))) aoidParamSetting.setEnable(1);
            else aoidParamSetting.setEnable(2);
            aoidParamSetting.setThreshold(String.valueOf(map.get("threshold")));
            list.add(aoidParamSetting);
        }
        return this.updateBatchById(list);
    }
}
