package com.gct.aoid.service.impl;

import com.gct.aoid.entity.Vo.JobStatusVo;
import com.gct.aoid.job.properties.JobConfigurationProperties;
import com.gct.aoid.job.properties.MutableJobConfigProperties;
import com.gct.aoid.job.statusEnum.JobStatusEnum;
import com.gct.aoid.service.EnableOrPauseService;
import com.gct.aoid.utils.LogFileUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.stereotype.Service;

import java.lang.reflect.Field;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

/**
 * class name: EnableOrPauseServiceImpl
 *
 * @author gxt
 * @version 1.0
 * @since 2021/8/12 下午3:57 周四
 */
@Service
@Slf4j
@EnableConfigurationProperties(MutableJobConfigProperties.class)
public class EnableOrPauseServiceImpl implements EnableOrPauseService {

    @Autowired
    MutableJobConfigProperties mutableJobConfigProperties;


    @Override
    public boolean CalDailyLiqJobIsRunning(boolean bool) {
        try {
            mutableJobConfigProperties.getCalDailyLiqJob().getParam().setRunning(bool);
            return mutableJobConfigProperties.getCalDailyLiqJob().getParam().isRunning();

        }catch (Exception e){
            e.printStackTrace();
            log.error("enable or pause error"+ LocalDateTime.now());
        }
        return false;
    }

    @Override
    public  String calDailyLiqJobIsStatus(String jobName){
        try {
            Field declaredField = mutableJobConfigProperties.getClass().getDeclaredField(jobName);
            declaredField.setAccessible(true);
            JobConfigurationProperties jobConfigurationProperties = (JobConfigurationProperties) declaredField.get(mutableJobConfigProperties);
            declaredField.setAccessible(false);
            String desc = JobStatusEnum.getDesc(jobConfigurationProperties.getParam().getStatus());
            return  desc;
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public List<JobStatusVo> getJobName() {
        try {
            JobStatusVo jobStatusVo = new JobStatusVo();
            List<String> fieldsValue = getFieldsValue(mutableJobConfigProperties);
            for (String s : fieldsValue) {
                if (s.equals("calDailyLiqJob")) {
                    jobStatusVo.setJobName(s);
                    jobStatusVo.setStatus(calDailyLiqJobIsStatus(s));
                }
            }
            jobStatusVo.setEndStartTime(LogFileUtils.getLastModifiedTime());
            jobStatusVo.setState(mutableJobConfigProperties.getCalDailyLiqJob().getParam().isRunning());
            List<JobStatusVo> list = new ArrayList<>();
            list.add(jobStatusVo);
            return list;
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }


    public List<String> getFieldsValue(Object obj){
        List<String> list = new ArrayList<>();
        Class objClass = obj.getClass();
        Field[] fields = objClass.getDeclaredFields();
        for(Field field : fields){
            try{
                field.setAccessible(true);
                list.add(field.getName());
                field.setAccessible(false);
            }   catch(Exception e){
                e.printStackTrace();
            }
        }
        return  list;
    }
}
