package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.rocketmq.AoidMsg;
import com.gct.aoid.service.TaskConsumerService;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.ConsumeMode;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.InvocationTargetException;

@Slf4j
@Service
@RocketMQMessageListener(
        nameServer = "${gct.rocketmq.aoid.name-server}",
        topic = "${gct.rocketmq.aoid.topic}",
        consumerGroup = "${gct.rocketmq.aoid.consumer.group}",
        accessKey = "${gct.rocketmq.aoid.consumer.access-key}",
        secretKey = "${gct.rocketmq.aoid.consumer.secret-key}",
        consumeMode = ConsumeMode.ORDERLY //保证同一队列顺序消费
)
public class TaskConsumerServiceImpl implements TaskConsumerService {

    @Autowired
    CalDiagramProductionService calDiagramProductionService;

    @Override
    public void onMessage(String message) {
        try {
            calDiagramProductionService.calWrapper(JSONObject.parseObject(message, AoidMsg.class));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
