package com.gct.aoid.utils;

import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.write.merge.AbstractMergeStrategy;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.util.CellRangeAddress;

import java.util.Map;

/**
 * class name: ExcelFileRowMergeStrategy
 *
 * @author gxt
 * @version 1.0
 * @since 2022/10/26 下午5:23 周三
 */
public class ExcelMergeStrategy extends AbstractMergeStrategy {


    private final Map<String, Integer[]> map;


    public ExcelMergeStrategy(Map<String, Integer[]> map) {
        this.map = map;
    }

    @Override
    protected void merge(org.apache.poi.ss.usermodel.Sheet sheet, Cell cell, Head head, Integer integer) {
        if (map.containsKey(head.getFieldName())){
            int integer1 = map.get(head.getFieldName())[cell.getRowIndex()-1];
            if (integer1<=1) return;
            CellRangeAddress  cellRangeAddress=new CellRangeAddress(cell.getRowIndex(),cell.getRowIndex()+integer1-1,head.getColumnIndex(),head.getColumnIndex());
            sheet.addMergedRegionUnsafe(cellRangeAddress);
        }
    }
}
