package com.gct.aoid;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.algorithm.CardAreaAlgorithm;
import com.gct.aoid.controller.AoidSinglegtYieldController;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.entity.Vo.LiqWarringVo;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.mapper.AoidSinglegtYieldMapper;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.EnableOrPauseService;
import com.gct.aoid.service.LiqProdDailyCalService;
import com.gct.aoid.service.impl.CalDiagramProductionService;
import com.gct.aoid.service.impl.CalibrationParameterService;
import com.gct.common.util.DateTimeUtil;
import com.gct.common.util.SGTUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.nio.charset.StandardCharsets;
import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;
import java.util.concurrent.CountDownLatch;
import java.util.stream.Collectors;

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class MyTest {
    @Autowired
    CalDiagramProductionService calDiagramProductionService ;
    @Autowired
    BaseDataClient client;
    @Autowired
    DiagnoseClient diagnoseClient;
    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    AoidDailyYieldService aoidDailyYieldService;
    @Autowired
    AoidSinglegtYieldController aoidSinglegtYieldController;
    @Autowired
    AoidSinglegtYieldMapper aoidSinglegtYieldMapper;
    @Autowired
    LiqProdDailyCalService liqProdDailyCalService;
//    @Autowired
//    SumDataTaskMapper sumDataTaskMapper;
//    @Autowired
//    AoidParamSettingService aoidParamSettingService;
//    @Autowired
//    AoidLiquidAbnormalService aoidLiquidAbnormalService;
//    private static final  Logger reload = (Logger) LoggerFactory.getLogger("reload");
//    @Test
//    public void test() {
//        List<AoidParamSetting> aoidParamSetting = aoidParamSettingService.getAoidParamSetting();
//        aoidLiquidAbnormalService.addAoidLiquidAbnormalNew(DateTimeUtil.formatDateTime("2021-08-18 00:00:00"),aoidParamSetting);
//    }
@Autowired
    EnableOrPauseService enableOrPauseService;

    @Test
    public void test1() throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {
        String[] x = {"27"};
        String starDate = "2022-07-05";
        String time = "16:00:00";
        liqProdDailyCalService.calculate(x,starDate,time);
    }

    @Autowired
    AoidSinglegtYieldMapper singlegtYieldMapper;
    @Test
    //@Scheduled
    public void test2(){
        LiqWarringVo liqWarringVo = new LiqWarringVo()
                .setWellId("CHW04").setPordDate("2021-08-17 00:00:00");

        System.out.println(aoidDailyYieldService.getLiqWarring(liqWarringVo));
    }


    @Autowired
    CalibrationParameterService calibrationParameterService;

    @Test
    public void testXs(){
        double sumArea = 0;
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        List<AoidSinglegtYield> results = aoidSinglegtYieldService.list(new QueryWrapper<AoidSinglegtYield>().eq("well_id", "车峰15")
                .between("prod_date", LocalDateTime.parse("2022-10-03 16:00:00",df)
                        , LocalDateTime.parse("2022-10-04 16:00:00",df)));
        String[] sgts = results.stream().map(AoidSinglegtYield::getSgt).collect(Collectors.toList()).toArray(new String[]{});

        for (int y = 0; y < sgts.length; y++) {

            List<List<Double>> sgtList = new ArrayList<>();
            if (Objects.nonNull(sgts[y])) {
                sgtList = SGTUtil.encodeToUseList(sgts[y]);
                if (Objects.nonNull(sgtList) && sgtList.size() > 1) {
                    sgtList.remove(sgtList.size() - 1);
                    sgtList.add(sgtList.get(0));
                }
                Double[][] sgtValue = JSONObject.parseObject(sgtList.toString(), Double[][].class);
                double areaReal = CardAreaAlgorithm.calArea(sgtValue);
                if (areaReal>0)
                {
                    sumArea += areaReal;
                }
            }

        }
        double areaAvg = sumArea/sgts.length;
        if (areaAvg<200)
        {
            System.out.println(calibrationParameterService.coefficientValue(0,results));
        }
    }
    
}