package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gct.aoid.ProductionCalApplication;
import com.gct.aoid.entity.AoidCalprotaskqueue;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.entity.ProDataForCalProduction;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.common.core.result.Result;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.codec.digest.PureJavaCrc32;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.lang.reflect.InvocationTargetException;
import java.time.LocalDateTime;
import java.util.UUID;

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class CalDiagramProductionServiceTest {

    @Autowired
    CalDiagramProductionService calDiagramProductionService;

    @Autowired
    DiagnoseClient diagnoseClient;

    @Autowired
    BaseDataClient baseDataClient;
    @Autowired
    private AoidSinglegtYieldService aoidSinglegtYieldService;

    @Test
    public void test() {

        JSONObject allResult = JSONObject.parseObject(diagnoseClient.getAllResult());

        JSONArray data = allResult.getJSONArray("data");
        System.out.println("data.size() = " + data.size());
        for (int i = 0; i < data.size(); i++) {
            AoidCalprotaskqueue msg = new AoidCalprotaskqueue();
            msg.setStatus(AoidCalprotaskqueue.TaskStatus.ADDED.getCode());
//            System.out.println("data.getJSONObject(i).toJSONString() = " + data.getJSONObject(i).toJSONString());
            msg.setDiagnoseresultId(data.getJSONObject(i).getString("resultId"));
            msg.setSgtbaseparamId(data.getJSONObject(i).getString("gtbaseparamId"));
            msg.setCreatetime(LocalDateTime.now());
            msg.setId(UUID.randomUUID().toString());

            //System.out.println("msg run completed=>>>>>>" + msg.toString());
        }


    }

    @Test
    public void test2() throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {
        String c129 = baseDataClient.getA2StatusDataForCalProduction("B1017", "2021-07-11");
//        System.out.println("B1017:Status = " + c129);
        ProDataForCalProduction status=   (ProDataForCalProduction) JSONObject.parseObject(c129, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
        System.out.println("status = " + status);
        c129 = baseDataClient.getA2VolDataForCalProduction("B1017", "2021-07-12");
        System.out.println("B1017:Vol = " + c129);
    }

    @Test
    public void test3(){
        String m1="{\"a2GasProdDaily\":319.0,\"a2LiqProdDaily\":72.5,\"a2OilProdDaily\":2.7,\"bgt\":\"15,-508,15,-485,14,-464,13,-444,12,-424,11,-403,10,-379,9,-351,8,-316,7,-274,6,-224,6,-165,5,-97,5,-21,4,64,4,154,4,249,3,346,3,445,3,541,3,634,3,723,3,805,3,880,4,948,4,1009,5,1064,5,1113,7,1159,8,1202,10,1244,13,1288,16,1333,19,1381,23,1432,28,1487,33,1545,38,1605,44,1666,50,1726,57,1785,64,1840,70,1889,77,1933,84,1969,91,1998,98,2019,104,2032,111,2039,117,2041,123,2040,129,2037,136,2034,142,2034,148,2036,154,2044,160,2057,166,2076,172,2101,178,2132,184,2167,190,2206,196,2247,202,2287,208,2327,214,2364,220,2397,225,2426,230,2449,235,2468,240,2482,245,2492,249,2499,253,2505,257,2510,261,2517,265,2526,269,2538,273,2554,276,2574,280,2598,283,2625,286,2655,289,2686,292,2717,295,2746,298,2773,300,2796,303,2814,305,2827,307,2835,308,2837,309,2834,311,2827,312,2817,312,2806,313,2793,314,2782,314,2772,314,2764,314,2762,314,2757,314,2754,314,2753,314,2752,314,2751,314,2747,313,2740,313,2727,312,2707,312,2678,311,2640,310,2592,309,2534,308,2467,307,2391,306,2308,305,2220,304,2129,303,2036,303,1945,302,1856,302,1771,302,1691,302,1617,302,1550,302,1487,302,1430,302,1377,302,1326,302,1275,301,1223,299,1169,298,1112,295,1050,292,984,289,913,285,837,281,759,276,679,270,600,265,522,259,448,253,379,246,317,240,264,234,218,228,181,221,153,215,132,209,116,203,105,198,97,192,90,186,81,180,69,175,54,169,33,163,7,157,-24,152,-60,146,-100,140,-142,135,-186,129,-230,123,-271,118,-310,113,-343,108,-372,103,-395,98,-413,93,-426,89,-434,84,-440,80,-444,76,-448,72,-454,68,-462,64,-473,60,-489,56,-509,53,-532,49,-559,46,-589,42,-619,39,-649,36,-677,34,-701,31,-720,29,-733,27,-740,25,-739,24,-731,23,-717,22,-697,21,-673,20,-645,19,-616,19,-587,18,-558\",\"bj\":0.0,\"bs\":1150.0,\"calIsNormal\":0,\"cmd\":19.5,\"dym\":1130.5,\"eczdjg\":\"泵工作正常\",\"frequence\":6.0,\"hsl\":96.3,\"hy\":0.12,\"prodDate\":\"2021-07-12T09:25:00\",\"remark\":\"缺失水比重\\n缺失气油比\",\"scsj\":24.0,\"sgt\":\"0,2876,0,2953,0,3029,1,3106,2,3182,3,3259,4,3336,5,3412,7,3489,8,3565,10,3642,13,3697,15,3752,17,3807,20,3862,23,3917,26,3972,30,4027,33,4081,37,4136,40,4191,44,4311,49,4431,53,4550,57,4670,62,4790,67,4910,72,5030,77,5149,82,5269,87,5389,93,5398,98,5408,104,5417,110,5427,116,5436,122,5448,128,5459,134,5471,140,5482,146,5407,153,5332,159,5256,165,5181,172,5106,178,5031,185,4955,192,4880,198,4922,205,4964,211,5005,218,5047,225,5089,231,5131,238,5172,244,5214,251,5160,257,5105,264,5051,270,4996,276,4942,283,4887,289,4833,295,4778,301,4788,307,4798,313,4808,319,4818,324,4828,330,4838,335,4847,340,4857,345,4853,350,4850,355,4846,360,4842,365,4838,369,4834,373,4830,377,4826,381,4819,385,4811,389,4804,392,4796,395,4788,398,4781,401,4773,404,4765,406,4767,408,4768,410,4770,412,4771,414,4772,415,4774,417,4775,418,4776,419,4777,419,4779,420,4780,420,4781,420,4782,420,4784,419,4785,419,4786,418,4749,417,4712,416,4675,414,4638,413,4601,411,4564,409,4527,406,4490,404,4480,401,4469,399,4459,395,4448,392,4438,389,4427,385,4417,382,4406,378,4273,374,4141,369,4008,365,3875,360,3742,356,3610,351,3477,346,3344,341,3240,336,3135,330,3031,325,2926,319,2821,313,2717,308,2612,302,2507,296,2536,290,2564,283,2593,277,2621,271,2649,265,2678,258,2706,252,2734,245,2756,239,2778,232,2800,225,2822,219,2844,212,2866,206,2888,199,2910,192,2882,186,2854,179,2825,173,2797,166,2769,160,2740,153,2712,147,2683,141,2724,134,2765,128,2805,122,2846,116,2887,110,2928,105,2968,99,3009,93,2987,88,2965,83,2943,77,2921,72,2899,67,2877,63,2855,58,2833,53,2858,49,2882,45,2907,41,2931,37,2955,33,2980,30,3004,27,3028,23,3039,20,3049,18,3060,15,3070,13,3080,11,3091,9,3101,7,3111,5,3127,4,3143,3,3159,2,3175,1,3100,0,3026,0,2951,0,2876\",\"sgtIsLegal\":1,\"stroke\":4.2,\"sxzh\":54.82,\"ty\":5.5,\"wellCommonName\":\"C1024\",\"wellId\":\"C1024\",\"xxzh\":25.07,\"ymd\":0.85,\"yy\":0.0,\"yzzj\":0.0,\"zdjg\":\"1\"}";

        AoidSinglegtYield aoidSinglegtYield = JSONObject.parseObject(m1, AoidSinglegtYield.class);
        if (!aoidSinglegtYieldService.update(aoidSinglegtYield,new LambdaUpdateWrapper<AoidSinglegtYield>()
                .eq(AoidSinglegtYield::getWellId, aoidSinglegtYield.getWellId())
                .eq(AoidSinglegtYield::getProdDate, aoidSinglegtYield.getProdDate())))
            aoidSinglegtYieldService.save(aoidSinglegtYield);
    }
}